<?
// Put here the same folder that in CGI
define ( "TEMP_DIR", $_SERVER['DOCUMENT_ROOT']."/tmp/" );
//---------------->

include ( "xml.class.php" );

//simple function to translate bites size into somethign more easily readable
function format_size ( $size ){
	// Measure & Number of decimals
	$measures = array (
		0 => array ( "B", 0 ),
		1 => array ( "KB", 0 ),
		2 => array ( "MB", 1 ),
		3 => array ( "GB", 2 ),
		4 => array ( "TB", 2 )
	);

	$file_size = $size;

	for ( $i = 0; $file_size >= 1024; $i++ ){
		$file_size = $file_size / 1024;
	}
	$file_size = number_format ( $file_size, $measures[$i][1] );
	return $file_size." ".$measures[$i][0];
}

/*****
* Begin script's flux
*/

//we define valid actions
$valid_actions = array ( "none", "upload_progressbar", "upload_finish" );
if ( !in_array ( $_REQUEST["action"], $valid_actions ) ) $_REQUEST["action"] = $valid_actions[0];

switch ( $_REQUEST["action"] )
{
	case "upload_finish" :
		$xml = new XmlWriter();
		$xml->push('response');
		
		//if download is finished, we delete the temp raw post data file & additional ones
		if ( file_exists(TEMP_DIR.$_REQUEST["sid"]."_signal") )
		{
			unlink(TEMP_DIR.$_REQUEST["sid"]."_signal");
			unlink(TEMP_DIR.$_REQUEST["sid"]."_qstring");
			unlink(TEMP_DIR.$_REQUEST["sid"]."_flength");
			unlink(TEMP_DIR.$_REQUEST["sid"]."_postdata");
			$xml->element('status', 'ok');
		}
		else	//or return KO status if it doesn't exists
			$xml->element('status', 'ko');
			
		$xml->pop();
		print $xml->getXml();
		
		break;
	case "upload_progressbar" :
	
		header('Content-type: application/xml', true);
		$xml = new XmlWriter();
		$xml->push('response');

		if ( $_REQUEST["sid"] )
		{
			if ( file_exists ( TEMP_DIR.$_REQUEST["sid"]."_signal" ) )	//upload is finished
			{
				$xml->element('status', 'finished');
			}
			elseif ( file_exists ( TEMP_DIR.$_REQUEST["sid"]."_postdata" ) ) //upload in progress
			{
				$total_size 	= file_get_contents ( TEMP_DIR.$_REQUEST["sid"]."_flength" );
				$loaded_size 	= filesize ( TEMP_DIR.$_REQUEST["sid"]."_postdata" );
				$percent_loaded= round ( $loaded_size / $total_size * 100 );
				
				$xml->element('total', format_size($total_size) );
				$xml->element('loaded', format_size($loaded_size) );
				$xml->element('percent', $percent_loaded);
				$xml->element('status', 'loading');
			}
			else											//upload hasn't begin yet
			{
				$xml->element('status', 'wait');
			}
		}
		else
		{
			$xml->element('status', 'error');				//sid empty
		}
		
		$xml->pop();
		print $xml->getXml();
		
		break;
}
?>